discussion/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
                               #app     #endpoint
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls),
]

todolist/urls.py
from django.urls import path

from . import views

app_name= 'todolist'

urlpatterns = [
	# The path() function receives four(4) arguments
	# We'll focus on 2 arguments that are rquired: 'route' and 'view'
		#route
			#view			#label, *optional
	path('', views.index, name='index'),

	# todoitem/1 (or 2, 3, ...) <general endpoint
	# The '<int:todoitem_id>/' allows for creating a dynamic link where the todolist_id is provided
	path('<int:todoitem_id>/', views.todoitem, name = "viewtodoitem"),

	path('register', views.register, name = "register"),
	path('change_password', views.change_password, name = "change_password"),
	path('login', views.login_view, name = "login"),
	path('logout', views.logout_view, name = "logout"),
	path('add_task', views.add_task, name = "add_task"),

	# update_task path
	path('<int:todoitem_id>/edit', views.update_task, name='update_task'),
	# /todolist/<todoitem_id>/delete route
	path('<int:todoitem_id>/delete', views.delete_task, name='delete_task'),
	

	path('add_event', views.add_event, name = "add_event"),
	path('events/<int:eventitem_id>/', views.eventitem, name = "vieweventitem"),
	path('events/<int:eventitem_id>/edit', views.update_event, name='update_event'),
	path('events/<int:eventitem_id>/delete', views.delete_event, name='delete_event'),

	path('update_profile', views.update_profile, name = "update_profile"),
]

todolist/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils import timezone

# Create your models here.
class ToDoItem(models.Model):
	task_name = models.CharField(max_length=50)
	description = models.CharField(max_length=200)
	status = models.CharField(max_length=50, default = "pending")
	date_created = models.DateTimeField('date created')

	user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

class EventItem(models.Model):
	event_name = models.CharField(max_length=50)
	description = models.CharField(max_length=200)
	status = models.CharField(max_length=50, default = "pending")
	date_created = models.DateTimeField('date created', default=timezone.now)
	date_modified = models.DateTimeField('date modified', default=timezone.now)
	event_date = models.DateTimeField('event date', default=timezone.now)
	
	user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

todolist/forms.py
from django import forms
# from django.db import models
from django.utils import timezone


class LoginForm(forms.Form):
	username = forms.CharField(label="Username", max_length=20)
	password = forms.CharField(label="Password", max_length=20)

class AddTaskForm(forms.Form):
	task_name = forms.CharField(label="Task Name", max_length=20)
	description = forms.CharField(label="Description", max_length=20)

class RegisterForm(forms.Form):
	username = forms.CharField(label="Username", max_length=20)
	first_name = forms.CharField(label="First Name", max_length=20)
	last_name = forms.CharField(label="Last Name", max_length=20)
	email = forms.CharField(label="Email", max_length=20)
	password = forms.CharField(label="Password", max_length=20)
	confirm_password = forms.CharField(label="Confirm Password", max_length=20)


class UpdateTaskForm(forms.Form):
		# If fields are optional, using the "Model.save()" method will not work
		# Using the option "required=False" will allow the field to be optional when updating a record
		# task_name = forms.CharField(label='Task Name', max_length=50, required=False)
	task_name = forms.CharField(label='Task Name', max_length=50, required=False)
	description = forms.CharField(label='Description', max_length=200, required=False)
	status = forms.CharField(label='Status', max_length=50, required=False)


class AddEventForm(forms.Form):
	event_name = forms.CharField(label="Event Name", max_length=50)
	description = forms.CharField(label="Description", max_length=200)
	event_date = forms.DateTimeField(label="Event Date", input_formats=['%Y-%m-%d'])

class UpdateEventForm(forms.Form):
	event_name = forms.CharField(label='Event Name', max_length=50, required=False)
	description = forms.CharField(label='Description', max_length=200, required=False)

	status = forms.CharField(label='Status', max_length=50, required=False)


class ChangePasswordForm(forms.Form):
	password = forms.CharField(label="Password", max_length=20)
	new_password = forms.CharField(label="New Password", max_length=20)
	confirm_new_password = forms.CharField(label="Confirm New Password", max_length=20)

class UpdateProfileForm(forms.Form):
	username = forms.CharField(label="Username", max_length=20, required=False)
	first_name = forms.CharField(label="First Name", max_length=20, required=False)
	last_name = forms.CharField(label="Last Name", max_length=20, required=False)
	email = forms.CharField(label="Email", max_length=20, required=False)

todolist/views.py
from django.shortcuts import render, redirect, get_object_or_404

# Create your views here.
from django.http import HttpResponse

# Local imports
from .models import ToDoItem, EventItem
from .forms import LoginForm, RegisterForm, AddTaskForm, UpdateTaskForm, AddEventForm, UpdateEventForm, ChangePasswordForm, UpdateProfileForm

from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.hashers import make_password
from django.forms.models import model_to_dict
from django.utils import timezone


def index(request):
	# todoitem_list = ToDoItem.objects.all()
	todoitem_list = ToDoItem.objects.filter(user_id = request.user.id)
	eventitem_list = EventItem.objects.filter(user_id = request.user.id)

	context = {
		"todoitem_list" : todoitem_list,
		"eventitem_list" : eventitem_list,
		"user" : request.user
	}
	# context = {'todoitem_list' : todoitem_list}

	return render(request, "todolist/index.html", context)
	# return HttpResponse("Hello from the views.py file")

def todoitem(request, todoitem_id):

	# todoitem = model_to_dict(ToDoItem.objects.get(pk=todoitem_id))
	todoitem = get_object_or_404(ToDoItem, pk=todoitem_id)

	# response = "You are viewing the details of %s"

	# return HttpResponse(response %todoitem_id)
	# return render(request, "todolist/todoitem.html", todoitem)
	return render(request, "todolist/todoitem.html", model_to_dict(todoitem))

def register(request):

	context = {}

	if request.method == "POST":
		form = RegisterForm(request.POST)
		if form.is_valid() == False:
			form = RegisterForm()
		else:
			username = form.cleaned_data['username']
			first_name = form.cleaned_data['first_name']
			last_name = form.cleaned_data['last_name']
			email = form.cleaned_data['email']
			password = form.cleaned_data['password']
			confirm_password = form.cleaned_data['confirm_password']

			if password == confirm_password:
				duplicate = User.objects.filter(username = username)

				if not duplicate:
					User.objects.create(username=username, first_name=first_name, last_name=last_name, email=email, password=make_password(password), is_staff = False,is_active = True)
					return redirect("todolist:index")
				else:
					context = {
						"error" : True,
						"username_taken" : True
					}
			else:
				context = {
					"error" : True,
					"passwords_mismatch" : True
				}

	# users = User.objects.all()
	# is_user_registered = False
	# context = {
	# 	"is_user_registered" : is_user_registered
	# }

	# # check if username already exist
	# for indiv_user in users:
	# 	if indiv_user.username == "johndoe":
	# 		is_user_registered = True
	# 		break;
	# if is_user_registered == False:
	# 	user = User() #empty object
	# 	user.username = "johndoe"
	# 	user.first_name = "John"
	# 	user.last_name = "Doe"
	# 	user.email = "john@mail.com"
	# 	# The 'set_password' is used to ensure that the passord is hashed using Django's authentication framework
	# 	user.set_password("John1234")
	# 	user.is_staff = False
	# 	user.is_active = True
	# 	user.save()

	# 	context = {
	# 		"first_name" : user.first_name,
	# 		"last_name" : user.last_name,
	# 	}

	return render(request, "todolist/register.html", context)

def change_password(request):
	# is_user_authenticated = False

	# user = authenticate(username="johndoe", password="John1234")
	# print(user)
	# if user is not None:
	# 	authenticated_user = User.objects.get(username='johndoe') # this is where we get the username "johndoe"
	# 	authenticated_user.set_password("johndoe1") # this is where we change password
	# 	authenticated_user.save()
	# 	is_user_authenticated = True
	# context = {
	# 	"is_user_authenticated": is_user_authenticated
	# }

	context = {
		"user" : request.user
	}
	if request.method == "POST":
		form = ChangePasswordForm(request.POST)
		if form.is_valid() == False:
			form = ChangePasswordForm()
		else:
			password = form.cleaned_data['password']
			user = authenticate(username=request.user.username, password=password)
			context = {
				"username" : request.user.username,
				"password" : password
			}

			if user is not None:
				new_password = form.cleaned_data['new_password']
				confirm_new_password = form.cleaned_data['confirm_new_password']

				if new_password == confirm_new_password:
					user.set_password(new_password)
					user.save()
					return redirect("todolist:index")
				else:
					context = {
						"error" : True,
						"passwords_mismatch" : True
					}					
			else:
				context = {
					"error" : True,
					"incorrect_password" : True
				}

	return render(request, "todolist/change_password.html", context)

def login_view(request):

	context = {}

	if request.method == "POST":
		# Create a form instance and populate it with data from the request
		form = LoginForm(request.POST)
		# Check if data is valid
		# Runs validation for all the form fields and returns and places the form's data in the cleaned_data attribute
		if form.is_valid() == False:
			# Return a blank login form
			form = LoginForm()
		else:
			# Receives the information form the form
			username = form.cleaned_data['username']
			password = form.cleaned_data['password']
			user = authenticate(username=username, password=password)
			context = {
				"username" : username,
				"password" : password
			}
			if user is not None:
				# Saves the user’s ID in the session using Django's session framework
				login(request, user)
				return redirect("todolist:index")
			else:
				# Provides context with error to conditionally render the error message
				context = {
					"error" : True
				}

	return render(request, "todolist/login.html", context)


	# username = "johndoe"
	# password = "johndoe1"
	# user = authenticate(username=username, password=password)
	# context = {
	# 	"is_user_authenticated" : False
	# }
	# print(user)
	# if user is not None:
	# 	login(request, user)
	# 	return redirect("todolist:index")
	# else:
	# 						#templates/todolist/login.html
	# 	return render(request, "todolist/login.html", context)

def logout_view(request):
	logout(request)
	return redirect("todolist:index")

def add_task(request):

	context = {}
	# empty by default, so no value

	if request.method == "POST":
		form = AddTaskForm(request.POST)
		if form.is_valid() == False:
			form = AddTaskForm()
		else:
			task_name = form.cleaned_data['task_name']
			description = form.cleaned_data['description']
			duplicate = ToDoItem.objects.filter(task_name = task_name)

			if not duplicate:
				ToDoItem.objects.create(
					task_name=task_name, 
					description=description, 
					date_created=timezone.now(), 
					user_id = request.user.id
				)
				return redirect("todolist:index")
			else:
				context = {
					"error" : True
				}
	return render(request, "todolist/add_task.html", context)

def update_task(request, todoitem_id):

	# Returns a queryset
	todoitem = ToDoItem.objects.filter(pk=todoitem_id)

	context = {
		"user": request.user,
		"todoitem_id": todoitem_id,
			# Accessing the first element is necessary because the "ToDoItem.objects.filter()" method returns a queryset
		"task_name": todoitem[0].task_name,
		"description": todoitem[0].description,
		"status": todoitem[0].status
	}

	if request.method == 'POST':
		form = UpdateTaskForm(request.POST)
		if form.is_valid() == False:
			form = UpdateTaskForm()
		else:
			task_name = form.cleaned_data['task_name']
			description = form.cleaned_data['description']
			status = form.cleaned_data['status']

			if todoitem:
				todoitem[0].task_name = task_name
				todoitem[0].description = description
				todoitem[0].status = status

				todoitem[0].save()
				return redirect("todolist:index")
			else:
				context = {
					"error": True
				}
	return render(request, "todolist/update_task.html", context)

def delete_task(request, todoitem_id):
	todoitem = ToDoItem.objects.filter(pk=todoitem_id).delete()
	return redirect("todolist:index")


def eventitem(request, eventitem_id):
	eventitem = get_object_or_404(EventItem, pk=eventitem_id)
	return render(request, "todolist/eventitem.html", model_to_dict(eventitem))

def add_event(request):

	context = {}
	if request.method == "POST":
		form = AddEventForm(request.POST)
		if form.is_valid() == False:
			form = AddEventForm()
		else:
			event_name = form.cleaned_data['event_name']
			description = form.cleaned_data['description']
			event_date=form.cleaned_data['event_date']
			duplicate = EventItem.objects.filter(event_name = event_name)

			if not duplicate:
				EventItem.objects.create(
					event_name=event_name, 
					description=description, 
					date_created=timezone.now(),
					event_date=form.cleaned_data['event_date'],
					user_id = request.user.id
				)
				return redirect("todolist:index")
			else:
				context = {
					"error" : True
				}
	return render(request, "todolist/add_event.html", context)

def update_event(request, eventitem_id):

	eventitem = EventItem.objects.filter(pk=eventitem_id)

	context = {
		"user": request.user,
		"eventitem_id": eventitem_id,
		"event_name": eventitem[0].event_name,
		"event_date": eventitem[0].event_date,
		"description": eventitem[0].description,
		"status": eventitem[0].status
	}

	if request.method == 'POST':
		form = UpdateEventForm(request.POST)
		if form.is_valid() == False:
			print(form.errors)
			form = UpdateEventForm()
		else:
			event_name = form.cleaned_data['event_name']
			description = form.cleaned_data['description']
			# event_date = form.cleaned_data['event_date']
			status = form.cleaned_data['status']

			if eventitem:
				eventitem[0].event_name = event_name
				eventitem[0].description = description
				# eventitem[0].event_date = event_date
				eventitem[0].status = status
				eventitem[0].date_modified=timezone.now()

				eventitem[0].save()
				return redirect("todolist:index")
			else:
				context = {
					"error": True
				}
	return render(request, "todolist/update_event.html", context)

def delete_event(request, eventitem_id):

todolist/templates/todolist/add_event.html
{% extends 'base.html' %}
<!-- {% load crispy_forms_tags %} -->

{% block title %}
	Add Event
{% endblock %}

{% block content %}

{% if user.is_anonymous == False %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Add Event</h1>
				{% if error == True %}
					<p class="text-danger">Duplicate event found</p>
				{% endif %}
				<form action="{% url 'todolist:add_event' %}" method="post">
					{% csrf_token %}

					<div class="mb-3">
						<label for="event_name">Event Name: </label>
						<input class="form-control" id="event_name" type="text" name="event_name" value="{{ event_name }}" maxlength="50" required>
					</div>

					<div class="mb-3">
						<label for="description">Description: </label>
						<textarea class="form-control" id="description" name="description" value="{{ description }}" required></textarea>
					</div>

					<div class="mb-3">
						<label for="event_date">Event Date: </label>
						<input class="form-control" id="event_date" type="date" name="event_date" value="{{ event_date }}" required>
					</div>

					<div class="text-center">
						<input class="btn btn-success" type="submit" value="Add Event">
					</div>

				</form>
			</div>
		</div>
	</div>
	
{% else %}
    <h1 class="text-center mt-3">You are not authorized to access this page.</h1>
    <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
{% endif %}

{% endblock %}

todolist/templates/todolist/add_task.html
{% extends 'base.html' %}

{% block title %}
	Add Task
{% endblock %}

{% block content %}

{% if user.is_anonymous == False %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Add A Task</h1>
				{% if error == True %}
					<p class="text-danger">Duplicate task found</p>
				{% endif %}
				<form action="{% url 'todolist:add_task' %}" method="post">
					{% csrf_token %}

					<div class="mb-3">
						<label for="task_name">Task Name: </label>
						<input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
					</div>

					<div class="mb-3">
						<label for="description">Description: </label>
						<textarea class="form-control" name="description" value="{{ description }}" required></textarea>
					</div>

					<div class="text-center">
						<input class="btn btn-success" type="submit" value="Add Task">
					</div>

				</form>
			</div>
		</div>
	</div>

{% else %}
    <h1 class="text-center mt-3">You are not authorized to access this page.</h1>
    <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
{% endif %}

{% endblock %}

todolist/templates/todolist/change_password.html
{% extends 'base.html' %} 

<!-- {% if is_user_authenticated == False %}
	<h1>Invalid Credentials!</h1>
	<p>Check if the username and password is correct.</p>
{% else %}
	<h1>User Password Successfully Updated!</h1>
	<p>Password has been successfully updated.</p>
{% endif %} -->

{% block title %}
	Change Password
{% endblock %}

{% block content %}

{% if user.is_anonymous == False %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Change Password</h1>

				  <form action="{% url 'todolist:change_password' %}" method="post">
					{% csrf_token %}

					<div class="mb-3">
					    <label for="password">Old Password: </label>
					    <input class="form-control" id="password" type="password" name="password" value="{{ password }}" maxlength="20" required>
					</div>
					{% if incorrect_password %}
						<p class="text-danger">Incorrect Password.</p>
					{% endif %}

					<div class="mb-3">
					    <label for="new_password">New Password: </label>
					    <input class="form-control" id="new_password" type="password" name="new_password" value="{{ new_password }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="confirm_new_password">Confirm New Password: </label>
					    <input class="form-control" id="confirm_new_password" type="password" name="confirm_new_password" value="{{ confirm_new_password }}" maxlength="20" required>
					    {% if passwords_mismatch %}
					    	<p class="text-danger">Passwords do not match.</p>
					    {% endif %}
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Update Password">
					</div>

				  </form>
			</div>
		</div>
	</div>

{% else %}
    <h1 class="text-center mt-3">You are not authorized to access this page.</h1>
    <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
{% endif %}
	
{% endblock %}

todolist/templates/todolist/eventitem.html
{% extends 'base.html' %}

{% block title %}
	Event Items
{% endblock %}

{% block content %}
<div class="text-center my-3">
	<h1>{{ event_name }}</h1>
	<h3>Description</h3>
	<p>{{ description }}</p>
	<h3>Event Date</h3>
	<p>{{ event_date }}</p>	
	<h3>Status</h3>
	<p>{{ status }}</p>
	
	<button class="btn btn-primary mx-1 text-decoration-none">
		<a href="{% url 'todolist:update_event' id %}" class="text-light text-decoration-none">Edit Event</a>
	</button>

	<button class="btn btn-danger mx-1 text-decoration-none">
		<a href="{% url 'todolist:delete_event' id %}" class="text-light text-decoration-none">Delete Event</a>
	</button>

	<button class="btn btn-warning mx-1 text-decoration-none">
		<a href="{% url 'todolist:index' %}" class="text-light text-decoration-none">Back To Events</a>
	</button>
	
</div>

{% endblock %}

todolist/templates/todolist/index.html
{% extends 'base.html' %}

<!-- Provides the title of the page to be provided in the template -->
<!-- This should correspond with the block name provided in the base.html -->

{% block title %} home {% endblock %}

{% block content %}

{% if user.is_anonymous == False %}
    <h1 class="text-center my-3">Welcome {{ user.first_name }} {{user.last_name}}!</h1>
    
    <!-- to do list -->
    <div class="containter">
        <div class = "row">
            <h3 class="text-center mb-3">My Task</h3>

            {% if todoitem_list %}
            <ul class="list-group col-lg-2 offset-lg-5 text-center">
              {% for todoitem in todoitem_list %}
                <li><a href="{% url 'todolist:viewtodoitem' todoitem.id %}">{{ todoitem.task_name }}</a></li>
              {% endfor %}
            </ul>

            {% else %}
                <p class="text-center">No task/s have been created.</p>  
            {% endif %}

        </div>
    </div> 

    <!-- events -->
    <div class="containter mt-3">
        <div class = "row">
            <h3 class="text-center mb-3">My Events</h3>

            {% if eventitem_list %}
            <ul class="list-group col-lg-2 offset-lg-5 text-center">
              {% for eventitem in eventitem_list %}
                <li><a href="{% url 'todolist:vieweventitem' eventitem.id %}">{{ eventitem.event_name }}</a></li>
              {% endfor %}
            </ul>

            {% else %}
                <p class="text-center">No event/s have been created.</p> 
            {% endif %} 
        </div>
    </div> 

{% else %}
    <h1 class="text-center mt-3">You are not authorized to access this page.</h1>
    <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
{% endif %}

{% endblock %}

todolist/templates/todolist/register.html
{% extends 'base.html' %} 

<!-- {% if is_user_registered == False %}
	<h1>Duplicate User Found!</h1>
	<p>A duplicate user has been found, user creation unsuccessful.</p>
{% else %}
	<h1>User Successfully Created!</h1>
	<p>The account for {{firstname}} {{lastname}} has been successfully created.</p>
{% endif %} -->

{% block title %}
	Register
{% endblock %}

{% block content %}

{% if user.is_anonymous == True %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Register</h1>

				  <form action="{% url 'todolist:register' %}" method="post">
					{% csrf_token %}

					<div class="mb-3">
					    <label for="username">Username: </label>
					    <input class="form-control" id="username" type="text" name="username" value="{{ username }}" maxlength="20" required>
					    {% if username_taken %}
					    	<p class="text-danger">Username taken.</p>
					    {% endif %}
					</div>

					<div class="mb-3">
					    <label for="first_name">First Name: </label>
					    <input class="form-control" id="first_name" type="text" name="first_name" value="{{ first_name }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="last_name">Last Name: </label>
					    <input class="form-control" id="last_name" type="text" name="last_name" value="{{ last_name }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="email">Email: </label>
					    <input class="form-control" id="email" type="email" name="email" value="{{ email }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="password">Password: </label>
					    <input class="form-control" id="password" type="password" name="password" value="{{ password }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="confirm_password">Confirm Password: </label>
					    <input class="form-control" id="confirm_password" type="password" name="confirm_password" value="{{ confirm_password }}" maxlength="20" required>
					    {% if passwords_mismatch %}
					    	<p class="text-danger">Passwords do not match.</p>
					    {% endif %}
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Register">
					</div>

				  </form>
			</div>
		</div>
	</div>

{% else %}
    <h1 class="text-center mt-3">You are currently Logged In as "{{ user.first_name }} {{user.last_name}}".</h1>
    <p class="text-center"><a href="{% url 'todolist:logout' %}">Logout</a> first to register another account.</p>
{% endif %}

{% endblock %}

todolist/templates/todolist/todoitem.html
{% extends 'base.html' %}

{% block title %}
	To Do Items
{% endblock %}

{% block content %}
<div class="text-center my-3">
	<h1>{{ task_name }}</h1>
	<h3>Description</h3>
	<p>{{ description }}</p>
	<h3>Status</h3>
	<p>{{ status }}</p>
	
	<button class="btn btn-primary mx-1 text-decoration-none">
		<a href="{% url 'todolist:update_task' id %}" class="text-light text-decoration-none">Edit Task</a>
	</button>

	<button class="btn btn-danger mx-1 text-decoration-none">
		<a href="{% url 'todolist:delete_task' id %}" class="text-light text-decoration-none">Delete Task</a>
	</button>

	<button class="btn btn-warning mx-1 text-decoration-none">
		<a href="{% url 'todolist:index' %}" class="text-light text-decoration-none">Back To Tasks</a>
	</button>
	
</div>

{% endblock %}

todolist/templates/todolist/update_event.html
{% extends 'base.html' %}

{% block title %}
	Update Event
{% endblock %}

{% block content %}

{% if user.is_anonymous == False %}

	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Update Event</h1>

				{% if error == True %}
					<p class="text-danger">Event not found.</p>
				{% endif %}
				
				<form action="{% url 'todolist:update_event' eventitem_id %}" method="post">
					{% csrf_token %}

					<div class="mb-3">
					    <label for="task_name">Event Name:</label>
					    <input class="form-control" id="event_name" type="text" name="event_name" value="{{ event_name }}" maxlength="50" required>
					</div>

					<div class="mb-3">
					    <label for="description">Description:</label>
					    <textarea class="form-control" name="description" required>{{ description }}</textarea>
					</div>
					
					<div class="mb-3">
						<label for="event_date">Event Date: </label>
						<input class="form-control" id="event_date" type="date" name="event_date" value="{{ event_date }}" >
					</div>
					
					<div class="mb-3">
                        <label for="status">Status: </label>
                        <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
                    </div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Update Event">
					</div>

				</form>
			</div>
		</div>
	</div>

{% else %}
		<h1 class="text-center my-3">You are not authorized to access this page.</h1>
		<p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
{% endif %}

{% endblock %}

todolist/templates/todolist/update_profile.html
{% extends 'base.html' %} 

{% block title %}
	Update Profile
{% endblock %}

{% block content %}

{% if user.is_anonymous == False %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Update Profile</h1>

				  <form action="{% url 'todolist:update_profile' %}" method="post">
					{% csrf_token %}

					<div class="mb-3">
					    <label for="username">Username: </label>
					    <input class="form-control" id="username" type="text" name="username" value="{{ username }}" maxlength="20" required>
					    {% if username_taken %}
					    	<p class="text-danger">Username taken.</p>
					    {% endif %}
					</div>

					<div class="mb-3">
					    <label for="password">First Name: </label>
					    <input class="form-control" id="first_name" type="text" name="first_name" value="{{ first_name }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="password">Last Name: </label>
					    <input class="form-control" id="last_name" type="text" name="last_name" value="{{ last_name }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="password">Email: </label>
					    <input class="form-control" id="email" type="email" name="email" value="{{ email }}" maxlength="20" required>
					    {% if email_taken %}
					    	<p class="text-danger">This email already has an account.</p>
					    {% endif %}
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Update Profile">
					</div>

				  </form>
			</div>
		</div>
	</div>

{% else %}
    <h1 class="text-center mt-3">You are not authorized to access this page.</h1>
    <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
{% endif %}

{% endblock %}